var _used_product_name = "";

$(document).ready(function() {
	$("#menu_items").on("click",".menu_button", function(){
		var profile_path = $(this).attr("path");
		scan(profile_path);
	});
	
	$("#menu_items").on("click",".menu_item", function(){
  	var id = $(this).attr('id');
  	if(id == "btn_delete")
  		deleteImage();
  });
	
	enableAllControl(true);
	PlkScanOCX.Initialize("");
});

function getInternetExplorerVersion()
{
  var rv = -1;
  var browser_name = navigator.appName;
  if (browser_name == 'Microsoft Internet Explorer')
  {
    var ua = navigator.userAgent;
    var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
    if (re.exec(ua) != null)
      rv = parseFloat( RegExp.$1 );
  }
  else if (browser_name == 'Netscape')
  {
    var ua = navigator.userAgent;
    var re  = new RegExp("Trident/.*rv:([0-9]{1,}[\.0-9]{0,})");
    if (re.exec(ua) != null)
      rv = parseFloat( RegExp.$1 );
  }
  return rv;
}

function profileReady(json_obj)
{
	$("#menu_items").empty();
	var i=0;
	for(i=0;i<json_obj.count && i < 5;i++)
	{
		var name = json_obj.profiles[i].name;
		var profile_path = json_obj.profiles[i].path;
		
		var option = '<li id="' + name + '_scan" class="menu_button menu_scan_disabled" path="'+profile_path+'">';
		option += '<div style="margin-top:5px;" >Scan<br>';
		option += name;
		option += '</div></li>';
		option += '<li class="menu_separator"></li>';
		$("#menu_items").append(option);
	}
	
	AddDeleteMenuButton();
}

function AddDeleteMenuButton()
{
	var option = '<li id="btn_delete" class="menu_item" style="margin-left:10px;" title="Delete">';
	option +=	'<div style="margin-top:5px;">';
	option +=	'<img id="img_delete" src="images/delete.png"/>';
	option +=	'</div></li>';
	$("#menu_items").append(option);
}

function sourceReady(json_obj)
{
	if(json_obj.count == 0)
	{
		//$('#body_content').html("DEVICE NOT FOUND...");
		return;
	}
	
	var i=0;
	var default_product_name = "";
	for(i=0;i<json_obj.count;i++)
	{
		var pname = json_obj.sources[i].product_name;
		if(json_obj.sources[i].is_default)
			default_product_name = pname;
			
		var option = '<option value="';
		option += pname;
		option += '">';
		option += pname;
		option += '</option>';
		$("#scanner_sources").append(option);
	}
	
	if(default_product_name.length > 0)
	{
		_select_source(default_product_name);
	}
	else if(0 < json_obj.count)
	{
		_select_source(json_obj.sources[0].pname);
	}
}

function enableAllControl(enable) // enable:true/false
{
	$("#menu_items .menu_button").attr('disabled', !enable);
	$("#menu_items .menu_item").attr('disabled', !enable || PlkScanOCX.GetFileCount() == 0);
}

function select_source()
{
	var product_name = $("#scanner_sources").val();
	_select_source(product_name);
}

function _select_source(product_name)
{
	$("#scanner_sources").attr('disabled', "disabled");
	PlkScanOCX.ScannerRegister(product_name);
	_used_product_name = product_name;
}

function afterScannerRegister(json_obj)
{
	enableAllControl(0 == json_obj.code);
	if(0 != json_obj.code)
		_used_product_name = "";
}

function scan(profile_path)
{	
	if(profile_path.length == 0 || _used_product_name.length == 0) // for IE6~IE9
		return;
		
	enableAllControl(false);
	PlkScanOCX.SelectProfile(profile_path);
	
	PlkScanOCX.ScanStart(_used_product_name);
}

function scanEnd(json_obj)
{
	enableAllControl(true);
	
	var menu_disable = true;
	if(json_obj.code == 0)
		menu_disable = false;
	else
	{
		var img_count = PlkScanOCX.GetFileCount();
		menu_disable = (img_count == 0);
	}
		
	$("#menu_items .menu_item").attr('disabled', menu_disable);
}

function profileChange(profile_path)
{
	PlkScanOCX.SelectProfile(profile_path);
}

function deleteImage()
{
	if(!confirm("Are you sure you want to delete?"))
			return;
		
	PlkScanOCX.DeleteImage();
	var img_count = PlkScanOCX.GetFileCount();
	if(0==img_count)
	{
		disableDeleteBtn(true);
	}
}

function disableDeleteBtn(enable)
{
	$("#menu_items #btn_delete").attr('disabled', enable);
}

function OnProfileReady(data)
{
	json_obj = JSON.parse(data);
	profileReady(json_obj);
}

function OnSourceReady(data)
{
	json_obj = JSON.parse(data);
	sourceReady(json_obj);
}

function OnAfterScannerRegister(data)
{
	json_obj = JSON.parse(data);
	afterScannerRegister(json_obj);
}

function OnAfterScanSizesReady(data)
{
}

function OnScanEnd(data)
{
	json_obj = JSON.parse(data);
	scanEnd(json_obj);
}

function OnAfterSelectProfile(data)
{
	json_obj = JSON.parse(data);
	initSettings(json_obj);
}

function OnUIButtonStatusChange(data)
{
}