
var scanSizeUnit=0; // 0=Inch 1=Cm
$(document).ready(function() {
  $("#size_unit_cm").click(function(){
  	$("#size_unit_cm").attr("style", "color:#f87600;");
		$("#size_unit_inch").attr("style", "color:#000;");
		scanSizeUnit = 1;
		scanSizeChange();
  });
  
  $("#size_unit_inch").click(function(){
  	$("#size_unit_cm").attr("style", "color:#000;");
		$("#size_unit_inch").attr("style", "color:#f87600;");
		scanSizeUnit = 0;
		scanSizeChange();
  });
  
  $("ul.ul_collapse li>div").click(function() {
  	if($("#mode_bw").is(':disabled'))
			return;
			
		if(!$(this).hasClass("div_setting_name"))
			return;
			
    if ($(this).next().css("display") == "none") {
          $(".div_setting_name").next().hide("normal");
          $(".div_setting_name").children(".mark_arrow").removeClass("expanded");
          $(".div_setting_name").children(".mark_arrow").addClass("collapsed");
          $(this).next().show("normal");
          $(this).children(".mark_arrow").removeClass("collapsed");
          $(this).children(".mark_arrow").addClass("expanded");
    }
    else
    {
    	$(this).next().hide("normal");
    	$(this).children(".mark_arrow").removeClass("expanded");
      $(this).children(".mark_arrow").addClass("collapsed");
    }
	});
	
	$(".menu_item.view_select_group").click(function(){
  	$(".menu_item.view_select_group").removeClass("menu_item_select");
  	$(this).addClass("menu_item_select");
  	var id = $(this).attr('id');
  	onMenuClick(id);
  });
  
  $(".menu_item.view_group").click(function(){
  	$(".menu_item.view_group").removeClass("menu_item_select");
  	$(this).addClass("menu_item_select");
  	var id = $(this).attr('id');
  	onMenuClick(id);
  });
  
  $(".menu_item.image_op_group").click(function(){
  	$(".menu_item.image_op_group").removeClass("menu_item_select");
  	$(this).addClass("menu_item_select");
  	var id = $(this).attr('id');
  	onMenuClick(id);
  });
  
	$('input[name=scan_mode]').change(function() {
		var scan_mode = $(this).val();
		$('input[name=gray_bw_channel]').attr("disabled", scan_mode == 0 || scan_mode == 1 ? false : true ); //!$(this).is(':checked')
		$('#contrast_slider').slider({ disabled: (scan_mode == 0) ? true : false });
		$('#bw_threshold_slider').slider({ disabled: (scan_mode == 0) ? false : true });
		$('#advance_bw_threshold_auto').attr("disabled", (scan_mode == 0) ? false : true );
	});
	
	$('input[name=advance_split_merge]').change(function() {
		$('input[name=radio_split_merge]').attr("disabled", !$(this).is(':checked') );
	});
	
	$("input[name='output_format_bw_compression']").change(function() {
		if(2 == $(this).val())
			$('#output_format_bw_compression_level_slider').slider({ disabled: false });
		else
			$('#output_format_bw_compression_level_slider').slider({ disabled: true });
	});
	
	$('#output_format_multi_tiff').change(function() {
		var enable_multi_split = $(this).is(':checked') || $("#output_format_multi_pdf").is(':checked');
		$('input[name=output_format_split]').attr("disabled", !enable_multi_split);
	});
	
	$('#output_format_multi_pdf').change(function() {
		var enable_multi_split = $(this).is(':checked') || $("#output_format_multi_tiff").is(':checked');
		$('input[name=output_format_split]').attr("disabled", !enable_multi_split);
	});
	
	$('#bw_threshold1').keydown(function(event) {
      numberOnly(event);
  });
  
  $("#saveto_filename_helper").click(function() {
  	var helper_str = PlkScanOCX.GetFileNameHelper();
		PlkScanOCX.Alert("File Name", helper_str);
  });
  
  $("#saveto_filename").on("change keyup paste", function() {
	    var name_format = $(this).val();
	    var example_filename = PlkScanOCX.GetFileNameExample(name_format);
	    $("#saveto_filename_example").html("Example:"+example_filename+".jpg");
	});
  
  $("#device_buttons").change(function()
  {
		var btn_id =$(this).val();
		var profile_path = PlkScanOCX.GetConfigPath();
		PlkScanOCX.AssignProfileToScannerButton(btn_id, profile_path);
  });
		   
	menuItemAllDisable(true);  
	scanSizeChange();

	enableSelectBoxes();
	PlkScanOCX.Initialize("");
});

function getInternetExplorerVersion()
{
  var rv = -1;
  var browser_name = navigator.appName;
  if (browser_name == 'Microsoft Internet Explorer')
  {
    var ua = navigator.userAgent;
    var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
    if (re.exec(ua) != null)
      rv = parseFloat( RegExp.$1 );
  }
  else if (browser_name == 'Netscape')
  {
    var ua = navigator.userAgent;
    var re  = new RegExp("Trident/.*rv:([0-9]{1,}[\.0-9]{0,})");
    if (re.exec(ua) != null)
      rv = parseFloat( RegExp.$1 );
  }
  return rv;
}

function enableAllControl(enable)
{
	if(enable)
	{
		$("#scan_setting input").removeAttr("disabled");
		$("#scan_setting radio").removeAttr("disabled");
		$("#scan_setting checkbox").removeAttr("disabled");
		$("#scan_setting select").removeAttr("disabled");
		$('.slider').slider({ disabled: false });
		$("#size_unit_cm").removeAttr("disabled");
		$("#size_unit_inch").removeAttr("disabled");
		
		if(2 == $("input[name='output_format_bw_compression']").val())
			$('#output_format_bw_compression_level_slider').slider({ disabled: false });
  	else
  		$('#output_format_bw_compression_level_slider').slider({ disabled: true });
	}
	else
	{
		$("#scan_setting input").attr("disabled", "disabled");
		$("#scan_setting radio").attr("disabled", "disabled");
		$("#scan_setting checkbox").attr("disabled", "disabled");
		$("#scan_setting select").attr("disabled", "disabled");
		$('.slider').slider({ disabled: true });
		$("#size_unit_cm").attr("disabled", "disabled");
		$("#size_unit_inch").attr("disabled", "disabled");
		//$('#gamma_slider').slider({ disabled: true });
	}
}

function select_source()
{
	var product_name = $("#scanner_sources").val();
	_select_source(product_name);
}

function _select_source(product_name)
{
	$("#scanner_sources").attr('disabled', "disabled");
	PlkScanOCX.ScannerRegister(product_name);
}

function enableScanButton(enable)
{
	if(enable)
	{
		enableImageButton(enable, "export_profile_link", "export_profile_btn", 'images/export_profile.png');
		enableImageButton(enable, "scan_link", "scan_btn", 'images/scan.png');
		enableImageButton(enable, "save_link", "save_btn", 'images/save.png');
	}
	else
	{
		enableImageButton(enable, "export_profile_link", "export_profile_btn", 'images/export_profile_gray.png');
		enableImageButton(enable, "scan_link", "scan_btn", 'images/scan_gray.png');
		enableImageButton(enable, "save_link", "save_btn", 'images/save_gray.png');
	}
}

function enableImageButton(enable, link_id, btn_id, src_img)
{
	if(enable)
	{
		$("#"+link_id).removeAttr('disabled');
		$("#"+link_id).removeClass('DisabledLink');
		$("#"+btn_id).removeAttr('disabled', "disabled");
		$("#"+btn_id).removeClass('DisabledLink');
		
	}
	else
	{
		$("#"+link_id).addClass('DisabledLink');
		$("#"+link_id).attr('disabled', true);
		$("#"+btn_id).addClass('DisabledLink');
		$("#"+btn_id).attr('disabled', true);
	}
	
	$("#"+btn_id).attr('src', src_img);
}

var num_count_kent = 0;
function sourceReady(json_obj)
{
	$("#scanner_sources").val("");
	enableScanButton(0);
	enableAllControl(0);
	$("#size_unit_cm").attr("style", "color:#000;");
	$("#size_unit_inch").attr("style", "color:#f87600;");
		
	$('#scanner_sources').removeAttr("disabled");
	$(".selectArrow").attr("disabled", "disabled");
	$(".div_setting_name").attr("disabled", "disabled");
	
	$("#scanner_sources").empty();
	$("#scanner_sources").append('<option value = "" selected="selected">--Please select scanner--</option>')
	
	
	if(json_obj.count == 0)
	{
		$('#scanner_div').hide();
		$('#noscanner_div').show();
		return;
	}
	else
	{
		$('#scanner_div').show();
		$('#noscanner_div').hide();
	}
	
	var i=0;
	var default_product_name = "";
	for(i=0;i<json_obj.count;i++)
	{
		var pname = json_obj.sources[i].product_name;
		if(json_obj.sources[i].is_default)
			default_product_name = pname;
			
		var option = '<option value="';
		option += pname;
		option += '">';
		option += pname;
		option += '</option>';
		$("#scanner_sources").append(option);
		
	}

	if(default_product_name.length > 0)
	{
		$("#scanner_sources").val(default_product_name);
		select_source();
	}	
	else
		$("#scanner_sources").val("");
}

function profileReady(json_obj)
{
	var i=0;
	$('.selectOption').remove();
	var none_option = '<span class="selectOption" value="None">None</span>';
	$("#custom_profiles").append(none_option);
	
	var default_profile_idx = -1;	
	for(i=0;i<json_obj.count;i++)
	{
		var default_class = '';
		if(1 == json_obj.profiles[i].is_default)
		{
			default_class = ' optionSelected';
		}
			
		var name = json_obj.profiles[i].name;
		var prifile_path = json_obj.profiles[i].path;
		var option = '<span class="selectOption';
		option += default_class;
		option += '" value="';
		option += prifile_path;
		option += '">';
		option += name;
		option += '</span>';
		$("#custom_profiles").append(option);
	}
}

function afterScannerRegister(json_obj)
{
	if(0 != json_obj.code)
	{
		$("#custom_profile").html("None");
		$(".selectArrow").attr("disabled", "disabled");
		enableAllControl(0);
		$('#scanner_sources').removeAttr("disabled");
		enableScanButton(false);
		$(".div_setting_name").attr("disabled", "disabled");
		alert(json_obj.message);
	}
	else
	{
		$(".div_setting_name").removeAttr("disabled");
		$(".selectArrow").removeAttr("disabled");
		enableAllControl(1);
		$("input[name=scan_mode][value=" + 2 + "]").attr('checked', 'checked');
		$('input[name=advance_gray_bw_channel]').removeAttr("checked");
		$('input[name=gray_bw_channel]').attr("disabled", true);
		$('input[name=advance_split_merge]').removeAttr("checked");
		$('input[name=radio_split_merge]').attr("disabled", true);
		if(0 == json_obj.caps.source)
		{
			$('#type_front').attr('disabled', "disabled");
			$('#type_rear').attr('disabled', "disabled");
			$('#type_duplex').attr('disabled', "disabled");
			$('#adf_continuous').attr('disabled', "disabled");
		}
		else
		{
			$('#advance_auto_multi_crop').attr('disabled', "disabled");
			$("input[name=scan_type][value=" + 1 + "]").attr('checked', 'checked');
			if(0==json_obj.caps.is_duplex)
			{
				$('#type_rear').attr('disabled', "disabled");
				$('#type_duplex').attr('disabled', "disabled");
			}
			
			if(0==json_obj.caps.multi_page)
				$('#adf_continuous').attr('disabled', "disabled");
		}
		
		var enable_output_split = $("#output_format_multi_tiff").is(":checked") || $("#output_format_multi_pdf").is(":checked");
		if(!enable_output_split)
			$('input[name=output_format_split]').attr("disabled", true);
		else
			$('input[name=output_format_split]').attr("disabled", false);
		
		enableScanButton(true);
		if($("div.selectBox").children('div.selectOptions').children('span.optionSelected').length > 0)
		{
			var profile_path = $("div.selectBox").children('div.selectOptions').children('span.optionSelected').val();
			profileChange(profile_path);
		}
		else
			profileChange("");
	}
	
	$("#scanner_sources").removeAttr('disabled');
}

function scanSizeReady(json_obj)
{
	$("#size").empty();
	for(i=0;i<json_obj.count;i++)
	{
		var sname = json_obj.sizes[i].name;
		var option = '<option value="';
		option += json_obj.sizes[i].id;
		option += '" x="';
		option += json_obj.sizes[i].x;
		
		option += '" y="';
		option += json_obj.sizes[i].y;
		
		option += '" w="';
		option += json_obj.sizes[i].w;
		
		option += '" h="';
		option += json_obj.sizes[i].h;
		option += '"';
		
		option +='>';
		option += sname;
		option += '</option>';

		$("#size").append(option);
	}
	
	if(json_obj.count > 0)
	{
		//$('#size').find('option:first').attr('selected', 'selected');
		//enableCustomScanSize(false);
		if(json_obj.default_size_id == 0)
			$('#size').find('option:first').attr('selected', 'selected');
		else
			$('#size').val(json_obj.default_size_id);
		scanSizeChange();
	}
}

function enableSelectBoxes(){
	$('div.selectBox').each(function(){
		if($(this).children('div.selectOptions').children('span.optionSelected').length > 0)
		{
			$(this).children('span.selected').html($(this).children('div.selectOptions').children('span.optionSelected').html());
			$(this).attr('value',$(this).children('div.selectOptions').children('span.optionSelected').attr('value'));
		}
		else
		{
			$(this).children('span.selected').html($(this).children('div.selectOptions').children('span.selectOption:first').html());
			$(this).attr('value',$(this).children('div.selectOptions').children('span.selectOption:first').attr('value'));
		}
		
		$(this).children('span.selected,span.selectArrow').click(function(){
			if($("#mode_bw").is(':disabled'))
			{
				return;
			}
			
			if($(this).parent().children('div.selectOptions').css('display') == 'none'){
				$(this).parent().children('div.selectOptions').css('display','block');
			}
			else
			{
				$(this).parent().children('div.selectOptions').css('display','none');
			}
		});
		
		$(this).children('span.selected,span.selectArrow').focusout(function(){
			//$(this).parent().children('div.selectOptions').css('display','none');
		});
		
		$(this).on("click","span.selectOption", function() {
			if($("#mode_bw").is(':disabled'))
				return;
			
			$(this).parent().css('display','none');
			$(this).closest('div.selectBox').attr('value',$(this).attr('value'));
			$(this).parent().siblings('span.selected').html($(this).html());
			var profile_path = $(this).attr('value');
			if(profile_path.length > 0 && "None" != profile_path)
			{
				profileChange(profile_path);
			}
			else
			{
				profileChange("");
			}
		});
	});				
}

function scan()
{
	if($("#scan_link").is(':disabled')) // for IE6~IE9
		return;
		
	setScanParams();
	enableScanButton(false);
	$("#scanner_sources").attr('disabled', "disabled");
	var product_name = $("#scanner_sources").val();

	PlkScanOCX.ScanStart(product_name);
}

function setScanParams()
{
	// Basic
	if($("#type_front").is(':disabled'))
		PlkScanOCX.SetScanType(0);
	else
		PlkScanOCX.SetScanType($("input:radio[name ='scan_type']:checked").val());
	
	PlkScanOCX.SetContinuousScan($('#adf_continuous').is(':checked') ? 1 : 0);
	PlkScanOCX.SetScanMode($("input:radio[name ='scan_mode']:checked").val());
	var scan_size_id = $("#size").children('option:selected').val();
	if(1 < scan_size_id)
	{
		var x = $( "#custom_size_x" ).val();
		var y = $( "#custom_size_y" ).val();
		var w = $( "#custom_size_w" ).val();
		var h = $( "#custom_size_h" ).val();
  	if (!checkIsFloatValue(x))
  		x = 0.0;
  		
  	if (!checkIsFloatValue(y))
  		y = 0.0;
  	
  	if (!checkIsFloatValue(w))
  		w = 0.0;
  		
  	if (!checkIsFloatValue(h))
  		h = 0.0;
 
		PlkScanOCX.SetCustomScanSize(x, y, w, h, scanSizeUnit);
	}
	else
		PlkScanOCX.SetScanSize(scan_size_id);
	
	PlkScanOCX.SetResolution($( "#resolution" ).val());
	PlkScanOCX.SetRotate($( "#rotate" ).val());
	PlkScanOCX.SetGamma($( "#gamma_slider" ).slider( "value" ));
	PlkScanOCX.SetBrightness($( "#brightness_slider" ).slider( "value" ));
	PlkScanOCX.SetContrast($( "#contrast_slider" ).slider( "value" ));
	
	// Advance
	PlkScanOCX.SetProcessBlankPageRemoval($('#advance_blank_page_removal').is(':checked') ? 1 : 0);
	PlkScanOCX.SetProcessPunchHoleRemoval($('#advance_punch_hole_removal').is(':checked') ? 1 : 0);
	PlkScanOCX.SetProcessInvert($('#advance_invert').is(':checked') ? 1 : 0);
	PlkScanOCX.SetProcessWatermark($('#advance_watermark').is(':checked') ? 1 : 0);
	PlkScanOCX.SetProcessAutoOrientation($('#advance_auto_orientation').is(':checked') ? 1 : 0);
	if(!$("#advance_auto_multi_crop").is(':disabled'))
		PlkScanOCX.SetProcessAutoMultiCrop($('#advance_auto_multi_crop').is(':checked') ? 1 : 0);
	
	var scan_mode = $("input:radio[name ='scan_mode']:checked").val();
	if(0 == scan_mode || 1== scan_mode)
		PlkScanOCX.SetProcessGrayscaleChannel($("input:radio[name ='gray_bw_channel']:checked").val());
	else
		PlkScanOCX.SetProcessGrayscaleChannel(0);
		
	if($('#advance_split_merge').is(':checked'))
	{
		var split_merge_mode = $("input:radio[name ='radio_split_merge']:checked").val();
		if(1 == split_merge_mode || 2 == split_merge_mode)
			PlkScanOCX.SetSplitMerge(split_merge_mode);
		else
			PlkScanOCX.SetSplitMerge(0);
	}
	else
		PlkScanOCX.SetSplitMerge(0);
		
	if($("#advance_bw_threshold_auto").is(':checked'))
		PlkScanOCX.SetProcessBWThreshold(0);
	else
		PlkScanOCX.SetProcessBWThreshold($( "#bw_threshold_slider" ).slider( "value" ));
	var stroke_fill_size = $( "#edge_fill_size_slider" ).slider( "value" );
	PlkScanOCX.SetProcessStrokeFillSize(stroke_fill_size);
	if(0 != stroke_fill_size)
		PlkScanOCX.SetProcessStrokeFillPosition($("#advance_edge_fill").children('option:selected').val());
		
	// Output format	
	PlkScanOCX.SetOutputFormatBMP($('#output_format_bmp').is(':checked') ? 1 : 0);
	PlkScanOCX.SetOutputFormatJPG($('#output_format_jpg').is(':checked') ? 1 : 0);
	PlkScanOCX.SetOutputFormatPDF($('#output_format_pdf').is(':checked') ? 1 : 0);
	PlkScanOCX.SetOutputFormatTIFF($('#output_format_tiff').is(':checked') ? 1 : 0);
	PlkScanOCX.SetOutputFormatPNG($('#output_format_png').is(':checked') ? 1 : 0);
	PlkScanOCX.SetOutputFormatTIFFG4($('#output_format_tiff_g4').is(':checked') ? 1 : 0);
	PlkScanOCX.SetOutputFormatGIF($('#output_format_gif').is(':checked') ? 1 : 0);
	PlkScanOCX.SetOutputFormatMultiTIFF($('#output_format_multi_tiff').is(':checked') ? 1 : 0);
	PlkScanOCX.SetOutputFormatMultiPDF($('#output_format_multi_pdf').is(':checked') ? 1 : 0);
	
	var page_split = 0;
	if($('#output_format_blank_sheet_split').is(':checked'))
		page_split += 1;
	if($('#output_format_multi_pdf').is(':checked'))
		page_split += 2;
	PlkScanOCX.SetOutputPageSplit(page_split);
	
	PlkScanOCX.SetOutputJpegCompressionLevel($( "#jpeg_compression_level_slider" ).slider( "value" ));
	var bw_compress = $("input:radio[name ='output_format_bw_compression']:checked").val();
	if(2== bw_compress)
	{
		var jb2_compress = $( "#output_format_bw_compression_level_slider" ).slider( "value" );
		if(10 == jb2_compress)
			PlkScanOCX.SetOutputBWCompression(bw_compress*100);
		else
			PlkScanOCX.SetOutputBWCompression(jb2_compress*10);
	}
	else
		PlkScanOCX.SetOutputBWCompression(bw_compress*100);
	
	PlkScanOCX.SetOutputScaleX($( "#output_format_scale_x_slider" ).slider( "value" ));
	PlkScanOCX.SetOutputScaleY($( "#output_format_scale_y_slider" ).slider( "value" ));
	PlkScanOCX.SetOutputChangeResolution($( "#output_format_change_resolution_slider" ).slider( "value" ));
	
	// Save to
	PlkScanOCX.SetSavetoFolder($( "#saveto_save_folder" ).val());
	PlkScanOCX.SetSavetoIsOpenSaveFolder($("#saveto_is_open_folder").is(':checked') ? 1 : 0);
	PlkScanOCX.SetSavetoFileName($( "#saveto_filename" ).val());
	PlkScanOCX.SetSavetoLaunchAppPath($( "#saveto_launch_app_path" ).val());
	PlkScanOCX.SetSavetoLaunchAppParams($( "#saveto_launch_app_params" ).val());
}

function save()
{
	enableImageButton(false, "save_link", "save_btn", 'images/save_gray.png');
	setScanParams();
	var ret = PlkScanOCX.SaveProfile();
	var profile_path = PlkScanOCX.GetConfigPath();
	PlkScanOCX.Alert("Save", "Save complete.\r\nPath="+profile_path);
	enableImageButton(true, "save_link", "save_btn", 'images/save.png');
}

function scanEnd(json_obj)
{
	enableScanButton(true);
	$("#scanner_sources").removeAttr('disabled');
	
	var menu_disable = true;
	if(json_obj.code == 0)
		menu_disable = false;
	else
	{
		var img_count = PlkScanOCX.GetFileCount();
		menu_disable = (img_count == 0);
	}
		
	menuItemAllDisableAfterScanEnd(menu_disable);
}

function exportButtonMouseDown()
{
	if(!$("#export_profile_link").is(':disabled')) // for IE
		$("#export_profile_btn").attr('src', 'images/export_profile_down.png');
}

function exportButtonMouseUp()
{
	if(!$("#export_profile_link").is(':disabled')) // for IE
		$("#export_profile_btn").attr('src', 'images/export_profile.png');
}

function scanButtonMouseDown()
{
	if(!$("#scan_link").is(':disabled')) // for IE
		$("#scan_btn").attr('src', 'images/scan_down.png');
}

function scanButtonMouseUp()
{
	if(!$("#scan_link").is(':disabled')) // for IE
		$("#scan_btn").attr('src', 'images/scan.png');
}

function saveButtonMouseDown()
{
	if(!$("#save_link").is(':disabled')) // for IE
		$("#save_btn").attr('src', 'images/save_down.png');
}

function saveButtonMouseUp()
{
	if(!$("#save_link").is(':disabled')) // for IE
		$("#save_btn").attr('src', 'images/save.png');
}

function export_profile()
{
	enableImageButton(false, "export_profile_link", "export_profile_btn", 'images/export_profile.png');
	setScanParams();
	var ret = PlkScanOCX.ExportProfile();
	if(0 == ret)
	{
		PlkScanOCX.Alert("Export", "Export complete.");
		if($("div.selectBox").children('div.selectOptions').children('span.optionSelected').length > 0)
		{
			$("div.selectBox").children('span.selected').html($("div.selectBox").children('div.selectOptions').children('span.optionSelected').html());
			$("div.selectBox").attr('value',$("div.selectBox").children('div.selectOptions').children('span.optionSelected').attr('value'));
		}
	}
	else if(1 == ret)
	{
		// cancel export
	}
	else if(2 == ret)
		alert("Profile name can not be empty.");
	else if(3 == ret)
		alert("Export profile fail.");
	
	enableImageButton(true, "export_profile_link", "export_profile_btn", 'images/export_profile_gray.png');
}

function sliderControl(slider_id, slider_value_id, min_v, max_v, def_v, step_v, suffix_str)
{
	$( "#"+slider_id ).slider({
			value:def_v,
			min: min_v,
			max: max_v,
			step: step_v,
			slide: function( event, ui ) {
				if(suffix_str.length > 0)
				{
					$( "#"+slider_value_id ).val( ui.value + suffix_str );
				}
				else
					$( "#"+slider_value_id ).val( ui.value);
			}
		});
		
		if(suffix_str.length > 0)
		{
			$( "#"+slider_value_id ).val( $( "#"+slider_id ).slider( "value" ) + suffix_str )
		}
		else
			$( "#"+slider_value_id ).val( $( "#"+slider_id ).slider( "value" ) );
}

function sliderControlEx(slider_id, slider_value_id, min_v, max_v, def_v, step_v, v_add, v_denominator, suffix_str)
{
	if(v_denominator == 0)
		return;
		
	$( "#"+slider_id ).slider({
			value:def_v,
			min: min_v,
			max: max_v,
			step: step_v,
			slide: function( event, ui ) {
				if(suffix_str.length > 0)
				{
					$( "#"+slider_value_id ).val( (ui.value+v_add) / v_denominator + suffix_str );
				}
				else
					$( "#"+slider_value_id ).val( (ui.value+v_add) / v_denominator );
			}
		});
		
		if(suffix_str.length > 0)
			$( "#"+slider_value_id ).val( ($( "#"+slider_id ).slider( "value" )+v_add) / v_denominator + suffix_str );
		else
			$( "#"+slider_value_id ).val( ($( "#"+slider_id ).slider( "value" )+v_add) / v_denominator );
}

function sliderChangeOutputFormatScaleX()
{
	$( "#output_format_scale_x_slider" ).slider({
			value:100,
			min: 50,
			max: 200,
			step: 10,
			slide: function( event, ui ) {
				$( "#output_format_scale_x_value" ).val( ui.value );
				updateOutputScaleXPixels();
			}
		});
		
		var v = $( "#output_format_scale_x_slider" ).slider( "value" );
		$( "#output_format_scale_x_value" ).val( v );
		
		updateOutputScaleXPixels();
}

function sliderChangeOutputFormatScaleY()
{
	$( "#output_format_scale_y_slider" ).slider({
			value:100,
			min: 50,
			max: 200,
			step: 10,
			slide: function( event, ui ) {
				$( "#output_format_scale_y_value" ).val( ui.value );
				updateOutputScaleYPixels();
			}
		});
		
		var v = $( "#output_format_scale_y_slider" ).slider( "value" );
		$( "#output_format_scale_y_value" ).val( v );
		updateOutputScaleYPixels();
}

function sliderChangeResolutionControl()
{
	$( "#output_format_change_resolution_slider" ).slider({
			value:100,
			min: 50,
			max: 200,
			step: 10,
			slide: function( event, ui ) {
				$( "#output_format_change_resolution_value" ).val( ui.value );
				$( "#ouput_resolution" ).html("" + $( "#resolution" ).val() * ui.value / 100 + "dpi");
			}
		});
		
		var v = $( "#output_format_change_resolution_slider" ).slider( "value" );
		$( "#output_format_change_resolution_value" ).val( v );
		$( "#ouput_resolution" ).html("" + $( "#resolution" ).val() * v / 100 + "dpi");
}

function numberOnly(event)
{
	// Allow special chars + arrows 
  if (event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 
      || event.keyCode == 27 || event.keyCode == 13 
      || (event.keyCode == 65 && event.ctrlKey === true) 
      || (event.keyCode >= 35 && event.keyCode <= 39)){
          return;
  }else {
      // If it's not a number stop the keypress
      if ((number < 0 || number > 255) || event.shiftKey || (event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
          event.preventDefault(); 
      }  
  }
}

function scanSizeChange()
{
	var size_id = $("#size").children('option:selected').val();
	var x = $("#size").children('option:selected').attr("x");
	var y = $("#size").children('option:selected').attr("y");
	var w = $("#size").children('option:selected').attr("w");
	var h = $("#size").children('option:selected').attr("h");

	if(0 == size_id || 1 == size_id)
		enableCustomScanSize(false);
	else
		enableCustomScanSize(true);
	
	var rate = 1.0;
	if(0 != scanSizeUnit)
		rate = 2.54;

	$("#custom_size_x").val(x * rate);
	$("#custom_size_y").val(y * rate);
	$("#custom_size_w").val(w * rate);
	$("#custom_size_h").val(h * rate);
	
	updateOutputScaleXPixels();
	updateOutputScaleYPixels();
}

function enableCustomScanSize(enable)
{
	if(enable)
	{
		//$("#size_unit_cm").removeAttr("disabled");
		//$("#size_unit_inch").removeAttr("disabled");
		$("#custom_size_x").removeAttr("disabled");
		$("#custom_size_y").removeAttr("disabled");
		$("#custom_size_w").removeAttr("disabled");
		$("#custom_size_h").removeAttr("disabled");
		$("#custom_size_x").focus();
		//$("#size_unit_cm").attr("style", "color:#000;");
		//$("#size_unit_inch").attr("style", "color:#f87600;");
	}
	else
	{
		//$("#size_unit_cm").attr("disabled", "disabled");
		//$("#size_unit_inch").attr("disabled", "disabled");
		$("#custom_size_x").attr("disabled", "disabled");
		$("#custom_size_y").attr("disabled", "disabled");
		$("#custom_size_w").attr("disabled", "disabled");
		$("#custom_size_h").attr("disabled", "disabled");
	}
}

function checkIsFloatValue(v)
{
	var float_reg = new RegExp("^[0-9]*[.][0-9]+$");
	var int_reg = new RegExp("^[0-9]+$");
  if (v.match(int_reg) || v.match(float_reg))
  	return true;
  else
  	return false;
}

function getToSaveFolder()
{
	var folder = PlkScanOCX.SelectFolder();
	$("#saveto_save_folder").val(folder);
}

function getSavetoLaunchApp()
{
	var folder = PlkScanOCX.SelectAPFile();
	$("#saveto_launch_app_path").val(folder);
}

function profileChange(profile_path)
{
	PlkScanOCX.SelectProfile(profile_path);
}

function scanResolutionChange()
{
	var v = $( "#output_format_change_resolution_slider" ).slider( "value" );
	$( "#ouput_resolution" ).html("" + $( "#resolution" ).val() * v / 100 + "dpi");
	
	updateOutputScaleXPixels();
	updateOutputScaleYPixels();
}

function initSettings(json_obj)
{
	if(json_obj.ScanType != 0)
		$("input[name=scan_type][value=" + json_obj.ScanType + "]").prop('checked', true  );
	$('#adf_continuous').prop('checked', json_obj.ContinuousScan == 1 ? true : false);
	var scan_mode = json_obj.ScanMode;
	$("input[name=scan_mode][value=" + scan_mode + "]").prop('checked', true);
	$('input[name=gray_bw_channel]').attr("disabled", scan_mode == 0 || scan_mode == 1 ? false : true );
	var color_drop_out = json_obj.ColorDropOut;
	$("input[name=gray_bw_channel][value=" + color_drop_out + "]").prop('checked', true);
	$('#contrast_slider').slider({ disabled: (scan_mode == 0) ? true : false });
	$('#bw_threshold_slider').slider({ disabled: (scan_mode == 0) ? false : true });
	$('#advance_bw_threshold_auto').attr("disabled", (scan_mode == 0) ? false : true );
	
	var auto_size = json_obj.AutoSize;
	if(1 == auto_size)
	{
		$("#size").val(0); // auto size
		$("#custom_size_x").val(0);
		$("#custom_size_y").val(0);
		$("#custom_size_w").val(0);
		$("#custom_size_h").val(0);
	}
	else
	{
		$("#size").val(22);// custom size
		if(0 == json_obj.ScanType)
		{
			$("#custom_size_x").val(json_obj.FlatbedScanRangeX);
			$("#custom_size_y").val(json_obj.FlatbedScanRangeY);
			$("#custom_size_w").val(json_obj.FlatbedScanRangeW);
			$("#custom_size_h").val(json_obj.FlatbedScanRangeH);
		}
		else
		{
			$("#custom_size_x").val(json_obj.ADFFrontScanRangeX);
			$("#custom_size_y").val(json_obj.ADFFrontScanRangeY);
			$("#custom_size_w").val(json_obj.ADFFrontScanRangeW);
			$("#custom_size_h").val(json_obj.ADFFrontScanRangeH);
		}
	}
	
	$("#resolution").val(json_obj.ScanDpi);
	$("#rotate").val(json_obj.Rotate);
	$("#gamma_slider").slider("value", json_obj.Gamma);
	$("#gamma_value" ).val(json_obj.Gamma/100.0);
	$("#brightness_slider").slider("value", json_obj.Brightness);
	$("#brightness_value" ).val((json_obj.Brightness-100)/100.0);
	$("#contrast_slider").slider("value", json_obj.Contrast);
	$("#contrast_value" ).val((json_obj.Contrast-100)/100.0);
	
	$('#advance_blank_page_removal').prop('checked', json_obj.BlankPageDetect == 1 ? true : false);
	$('#advance_punch_hole_removal').prop('checked', json_obj.PunchHoleErase == 1 ? true : false);
	$('#advance_invert').prop('checked', json_obj.INVERT == 1 ? true : false);
	$('#advance_auto_orientation').prop('checked', json_obj.Orientation == 2 ? true : false);
	$('#advance_auto_multi_crop').prop('checked', json_obj.FlatbedMultiCrop == 1 ? true : false);
	
	var split_merge = json_obj.SplitMerge;
	if(0 == split_merge || 1== split_merge || 2 == split_merge)
	{
		$("input[name=radio_split_merge][value=" + split_merge + "]").attr('checked', 'checked');
		$('input[name=advance_split_merge]').attr("checked", split_merge !=0 ? true : false );
		$('input[name=radio_split_merge]').attr("disabled", split_merge ==0 ? true : false );
	}
		
	var bw_threshold = json_obj.bw_Threshold;
	if(0 == bw_threshold)
	{
		$('#advance_bw_threshold_auto').prop('checked', true);
	}
	else
	{
		$('#advance_bw_threshold_auto').prop('checked', false);
		$("#bw_threshold_slider").slider("value", bw_threshold);
		$("#bw_threshold_value" ).val(bw_threshold);
	}
	$("#advance_edge_fill").val(json_obj.StrokeFillPosition);
	$("#edge_fill_size_slider").slider("value", json_obj.StrokeFillSize);
	$("#edge_fill_size_value" ).val(json_obj.StrokeFillSize);
	$('.OutputFormat').prop('checked', false);
	var output_format_setting = json_obj.OUT_IMG;
	var output_formats = output_format_setting.split(',');
	var enable_output_split = false;
	$.each(output_formats, function(key, value){
		if(0 == value)
			$("#output_format_bmp").prop('checked', true);
		else if(1 == value)
			$("#output_format_jpg").prop('checked', true);
		else if(2 == value)
			$("#output_format_pdf").prop('checked', true);
		else if(3 == value)
			$("#output_format_tiff").prop('checked', true);
		else if(4 == value)
			$("#output_format_png").prop('checked', true);
		else if(5 == value)
			$("#output_format_bmp").prop('checked', true);
		else if(6 == value)
			$("#output_format_tiff_g4").prop('checked', true);
		else if(7 == value)
			$("#output_format_gif").prop('checked', true);
		else if(8 == value)
		{
			$("#output_format_multi_tiff").prop('checked', true);
			enable_output_split = true;
		}
		else if(9 == value)
		{
			$("#output_format_multi_pdf").prop('checked', true);
			enable_output_split = true;
		}
	});
	
	$("#output_format_blank_sheet_split").prop('checked', (json_obj.PageSplit == 1 || json_obj.PageSplit == 3) ? true : false);
	$("#output_format_barcode_split").prop('checked', (json_obj.PageSplit == 2 || json_obj.PageSplit == 3) ? true : false);
	if(!enable_output_split)
	{
		$('input[name=output_format_split]').attr("disabled", true);
	}
	else
	{
		$('input[name=output_format_split]').attr("disabled", false);
	}
	
	$("#jpeg_compression_level_slider").slider("value", json_obj.COMPRESS);
	$("#jpeg_compression_level_value" ).val(json_obj.COMPRESS);
	var bw_compress = json_obj.BWCOMPRESS;
	if(2 == bw_compress || (bw_compress > 0.0 && bw_compress < 1.0))
	{
			$("input[name=output_format_bw_compression][value=2]").prop('checked', true);
			$('#output_format_bw_compression_level_slider').slider({ disabled: false });
			if(bw_compress > 0.0 && bw_compress < 1.0)
			{
				$("#output_format_bw_compression_level_slider").slider("value", bw_compress* 10);
				$("#output_format_bw_compression_level_value").val(bw_compress);
			}
			else
			{
				$("#output_format_bw_compression_level_slider").slider("value", 10);
				$("#output_format_bw_compression_level_value").val("1");
			}
	}
  else
  {
  		$("input[name=output_format_bw_compression][value=" + bw_compress + "]").prop('checked', true);
  		$('#output_format_bw_compression_level_slider').slider({ disabled: true });
  }
	
	$("#output_format_scale_x_slider").slider("value", json_obj.ZOOM_X);
	$("#output_format_scale_y_slider").slider("value", json_obj.ZOOM_Y);
	$("#output_format_scale_x_value").val(json_obj.ZOOM_X+"");
	$("#output_format_scale_y_value").val(json_obj.ZOOM_Y+"");
	
	$("#output_format_change_resolution_slider").slider("value", json_obj.CHANGE_DPI);
	$("#output_format_change_resolution_value").val(json_obj.CHANGE_DPI);
	$("#ouput_resolution").html("" + $( "#resolution" ).val() * json_obj.CHANGE_DPI / 100 + "dpi");
	
	updateOutputScaleXPixels();
	updateOutputScaleYPixels();
	
	$("#saveto_save_folder").val(json_obj.SaveToPath);
	$("#saveto_filename").val(json_obj.FileName);
	$("#saveto_launch_app_path").val(json_obj.APPath);
	$("#saveto_launch_app_params").val(json_obj.APParams);
	var example_filename = PlkScanOCX.GetFileNameExample(json_obj.FileName);
	$("#saveto_filename_example").html("Example:"+example_filename+".jpg");
}

function advanceWatermarkSetting()
{
	PlkScanOCX.OpenWatermarkSetting();
}

function updateOutputScaleXPixels()
{
	var rate = 1.0;
	if(0 != scanSizeUnit)
		rate = 2.54;
		
	var scale_x_v = $( "#output_format_scale_x_slider" ).slider( "value" );
	var pixels_w = parseInt($("#custom_size_w").val() / rate *$( "#resolution" ).val() * scale_x_v / 100);
	if(0 != pixels_w)
		$( "#output_format_scale_x_pixels" ).html("" + pixels_w + "pixels");
	else
		$( "#output_format_scale_x_pixels" ).html("");
}

function updateOutputScaleYPixels()
{
	var rate = 1.0;
	if(0 != scanSizeUnit)
		rate = 2.54;
	
	var scale_y_v = $( "#output_format_scale_y_slider" ).slider( "value" );
	var pixels_h = parseInt($("#custom_size_h").val() / rate *$( "#resolution" ).val() * scale_y_v / 100);
	if(0 != pixels_h)
		$( "#output_format_scale_y_pixels" ).html("" + pixels_h + "pixels");
	else
		$( "#output_format_scale_y_pixels" ).html("");
}


function OnProfileReady(data)
{
	json_obj = JSON.parse(data);
	profileReady(json_obj);
}

function OnSourceReady(data)
{
	json_obj = JSON.parse(data);
	sourceReady(json_obj);
}

function OnAfterScannerRegister(data)
{
	json_obj = JSON.parse(data);
	afterScannerRegister(json_obj);
}

function OnAfterScanSizesReady(data)
{
	json_obj = JSON.parse(data);
	scanSizeReady(json_obj);
}

function OnScanEnd(data)
{
	json_obj = JSON.parse(data);
	scanEnd(json_obj);
}

function OnAfterSelectProfile(data)
{
	json_obj = JSON.parse(data);
	initSettings(json_obj);
}

function OnUIButtonStatusChange(data)
{
	json_obj = JSON.parse(data);
	uiButtonStatusChange(json_obj);
}