function onMenuClick(id)
{
	if(id == 'btn_thumb_view_9')
		onMenuClickThumbView9();
	else if(id == 'btn_thumb_view_4')
		onMenuClickThumbView4();
	else if(id == 'btn_preview')
		onMenuPreView();
	else if(id == 'btn_normal_view')
		onMenuClickNormalView();
	else if(id == 'btn_full_view')
		onMenuClickFullView();
	else if(id == 'btn_zoom_out')
		onMenuClickZoomOut();
	else if(id == 'btn_zoom_in')
		onMenuClickZoomIn();
	else if(id == 'btn_to_first')
		onMenuClickToFirst();
	else if(id == 'btn_to_previous')
		onMenuClickToPrevious();
	else if(id == 'btn_to_next')
		onMenuClickToNext();
	else if(id == 'btn_to_last')
		onMenuClickToLast();
	else if(id == 'btn_delete')
		onMenuClickDelete();
	else if(id == 'btn_rotate_left')
		onMenuClickRotateLeft();
	
	else if(id == 'btn_rotate')
		onMenuClickRotate();
	else if(id == 'btn_rotate_right')
		onMenuClickRotateRight();
	else if(id == 'btn_cut')
		onMenuClickCut();
	else if(id == 'btn_flip')
		onMenuClickFlip();
	else if(id == 'btn_mirror')
		onMenuClickMirror();
		
	else if(id == 'btn_undo')
		onMenuClickUndo();
}

function onMenuClickThumbView9()
{
	PlkScanOCX.ViewThumb9();
	menuItemDisable("btn_undo", true);
}

function onMenuClickThumbView4()
{
	PlkScanOCX.ViewThumb4();
	menuItemDisable("btn_undo", true);
}

function onMenuPreView()
{
	PlkScanOCX.ViewSinglePage();
	menuItemDisable("btn_undo", true);
}

function onMenuClickNormalView()
{
	PlkScanOCX.NormalView();
}

function onMenuClickFullView()
{
	PlkScanOCX.FullView();
}

function onMenuClickZoomOut()
{
	var ret = PlkScanOCX.ZoomOut();
}

function onMenuClickZoomIn()
{
	var ret = PlkScanOCX.ZoomIn();
}

function onMenuClickToFirst()
{
	var ret = PlkScanOCX.GoFirstPage();
}

function onMenuClickToPrevious()
{
	var ret = PlkScanOCX.GoPrevPage();
}

function onMenuClickToNext()
{
	var ret = PlkScanOCX.GoNextPage();
}

function onMenuClickToLast()
{
	var ret = PlkScanOCX.GoLastPage();
}

function onMenuClickDelete()
{
	if(!confirm("Are you sure you want to delete?"))
		return;
		
	PlkScanOCX.DeleteImage();
	var img_count = PlkScanOCX.GetFileCount();
	if(0==img_count)
	{
		menuItemAllDisable(true);
	}
}

function onMenuClickRotateLeft()
{
	PlkScanOCX.RotateLeft();
	menuItemDisable("btn_undo", false);
}

function onMenuClickRotate()
{
	PlkScanOCX.Rotate();
	menuItemDisable("btn_undo", false);
}

function onMenuClickRotateRight()
{
	PlkScanOCX.RotateRight();
	menuItemDisable("btn_undo", false);
}

function onMenuClickCut()
{
	PlkScanOCX.Cut();
	menuItemDisable("btn_undo", false);
}

function onMenuClickFlip()
{
	PlkScanOCX.Flip();
	menuItemDisable("btn_undo", false);
}

function onMenuClickMirror()
{
	PlkScanOCX.Mirror();
	menuItemDisable("btn_undo", false);
}

function onMenuClickUndo()
{
	PlkScanOCX.Undo();
	menuItemDisable("btn_undo", true);
}

function menuItemDisable(id, disable)
{
	if(disable)
	{
		var id_name = id.substr(4);
		var src = "images/"+id_name + "_gray.png";
		var img_id = "img_"+id_name;
		//alert(img_id);
		$('#'+img_id).attr('src', src);
		$('#'+id).attr('disabled', 'disabled');
		$('#'+id).addClass('menu_item_disable');
	}
	else
	{
		var id_name = id.substr(4);
		var src =  "images/"+id_name + ".png";
		var img_id = "img_"+id_name;
		$('#'+img_id).attr('src', src);
		$('#'+id).removeClass('menu_item_disable');
		$('#'+id).removeAttr('disabled');
	}
}

function menuItemAllDisable(disable)
{
	menuItemDisable("btn_thumb_view_9", disable);
	menuItemDisable("btn_thumb_view_4", disable);
	menuItemDisable("btn_preview", disable);
	menuItemDisable("btn_normal_view", disable);
	menuItemDisable("btn_full_view", disable);
	menuItemDisable("btn_zoom_out", disable);
	menuItemDisable("btn_zoom_in", disable);
	menuItemDisable("btn_to_first", disable);
	menuItemDisable("btn_to_previous", disable);
	menuItemDisable("btn_to_next", disable);
	menuItemDisable("btn_to_last", disable);
	menuItemDisable("btn_delete", disable);
	menuItemDisable("btn_rotate_left", disable);
	menuItemDisable("btn_rotate", disable);
	menuItemDisable("btn_rotate_right", disable);
	menuItemDisable("btn_cut", disable);
	menuItemDisable("btn_flip", disable);
	menuItemDisable("btn_mirror", disable);
	menuItemDisable("btn_undo", disable);
}

function menuItemAllDisableAfterScanEnd(disable)
{
	menuItemDisable("btn_thumb_view_9", disable);
	menuItemDisable("btn_thumb_view_4", disable);
	menuItemDisable("btn_preview", disable);
	menuItemDisable("btn_delete", disable);
	menuItemDisable("btn_rotate_left", disable);
	menuItemDisable("btn_rotate", disable);
	menuItemDisable("btn_rotate_right", disable);
	menuItemDisable("btn_cut", disable);
	menuItemDisable("btn_flip", disable);
	menuItemDisable("btn_mirror", disable);
	menuItemDisable("btn_undo", disable);
}

function menuItemNavigationButtonEnable(enable_first, enable_prev, enable_next, enable_last)
{
	menuItemDisable("btn_to_first", !enable_first);
	menuItemDisable("btn_to_previous", !enable_prev);
	menuItemDisable("btn_to_next", !enable_next);
	menuItemDisable("btn_to_last", !enable_last);
}

function navigationButtonStatusChange(json_obj)
{
	menuItemNavigationButtonEnable(json_obj.first, json_obj.prev, json_obj.next, json_obj.last);
}

function menuItemViewButtonEnable(enable_normal_view, enable_full_view, enable_zoom_out, enable_zoom_in)
{
	menuItemDisable("btn_normal_view", !enable_normal_view);
	menuItemDisable("btn_full_view", !enable_full_view);
	menuItemDisable("btn_zoom_out", !enable_zoom_out);
	menuItemDisable("btn_zoom_in", !enable_zoom_in);
}

function viewButtonStatus(json_obj)
{
	menuItemViewButtonEnable(json_obj.normal_view, json_obj.full_view, json_obj.zoom_out, json_obj.zoom_in);
}

function uiButtonStatusChange(json_obj)
{
	if("navigation" == json_obj.button_type)
		navigationButtonStatusChange(json_obj);
	else if("zoom_view" == json_obj.button_type)
		viewButtonStatus(json_obj);
	else if("undo" == json_obj.button_type)
		menuItemDisable("btn_undo", !json_obj.enable);
	else if("cut" == json_obj.button_type)
		menuItemDisable("btn_cut", !json_obj.enable);
		
}